import numpy
import random
import evaluate


def SetParameters1( self, tam, gen, nv, omega, phig ) :
	self._tamanio = tam
	self._gen = gen
	self._nv  = nv
	self._omega = omega
	self._phi_g = phig
	self._const  = nv + 1
	self.Particulas = numpy.zeros( (tam, nv+2) )
	self.Velocidades = numpy.zeros( (tam, nv) )
	self.vmejorPar = numpy.zeros( nv+2 )

def SetLimits1( self, vmin, vmax ) :
	n = len( vmin )
	if n != self._nv :
		print( "ERROR: minima vector is different than the number of variables" ); 

	n = len( vmax )
	if n != self._nv :
		print( "ERROR: maxima vector is different than the number of variables" ); 

	self.Limites = numpy.zeros( (2, self._nv) )
	self.vamplitud = numpy.zeros( self._nv )
	self.vvelocidad = numpy.zeros( self._nv )
	i = 0
	while i < self._nv :
		self.Limites[0][i] = vmin[i]
		self.Limites[1][i] = vmax[i]
		self.vamplitud[i] = vmax[i] - vmin[i]
		self.vvelocidad[i] = abs( self.vamplitud[i] )
		i += 1

def InitializeParticles1( self ) :
	i = 0
	while i<self._tamanio :
		j = 0
		while j<self._nv :
			rand = random.random( )
			v = self.Limites[0][j] + rand * self.vamplitud[j]
			self.Particulas[i][j] = v
			j += 1
		i += 1

	# Para inicializar a la mejor partícula.
	# La mejor se guardará cuando se evalua cada partícula
	i = 0
	while i < self._nv :
		self.vmejorPar[i] = self.Particulas[0][i]
		i += 1

	f, g = evaluate.Evaluate( self._nv, self.Particulas[0] )
	self.vmejorPar[self._nv] = f
	self.vmejorPar[self._nv + 1] = g

def SearchBest( self ) :
	i = 0
	while i<self._tamanio :
		f = self.Particulas[i][self._nv]
		g = self.Particulas[i][self._const]

		# Here is the compasion with the best particle
		if g >=0 and self.vmejorPar[ self._const ] >= 0 :  # both are feasible
			if f  < self.vmejorPar[ self._nv ] :
				pass
			else :
				i += 1 
				continue

		elif g >=0 :        # Only the new one is feasible
			pass

		elif self.vmejorPar[ self._const ] >= 0: # The best one is feasible
			i += 1 
			continue

		elif g > self.vmejorPar[ self._const ] :  # The one with better constraints
			pass

		else :
			i += 1 
			continue

		j = 0
		while j <= self._const :
			self.vmejorPar[j] = self.Particulas[i][j]
			j += 1

		i += 1 

def EvaluateParticles1( self ) :
	i = 0
	while i<self._tamanio :
		f, g = evaluate.Evaluate( self._nv, self.Particulas[i] )
		self.Particulas[i][self._nv] = f
		self.Particulas[i][self._nv+1] = g
		i += 1

	SearchBest( self )

def InitializeVelocities1( self ) :
	i = 0
	while i<self._tamanio :
		j = 0
		while j<self._nv :
			rand = random.random( )
			v = -self.vvelocidad[j] + rand * 2.0 * self.vvelocidad[j]
			self.Velocidades[i][j] = v
			j += 1
		i += 1
			

class MOL:
	def __init__( self ) :
		_tamanio = 0   # Tamaño de la población
		_gen = 1   # Número de generaciones
		_nv = 0    # Número de variables
		_omega = 0.5  #
		_phi_p = 1.0  # 
		_phi_g = 1.0  # 
		_const = 0

	SetParameters = SetParameters1 
	SetLimits = SetLimits1 
	InitializeParticles = InitializeParticles1
	EvaluateParticles = EvaluateParticles1
	InitializeVelocities = InitializeVelocities1


	def NewVelocities( self, indice ) :
		i = indice
		j = 0
		while j<self._nv :
			rg = random.random( )
			g = self.vmejorPar[j] - self.Particulas[i][j]
			v = self._omega * self.Velocidades[i][j] + rg * self._phi_g * g

			if v < -self.vvelocidad[j] :
				v = -self.vvelocidad[j]
			elif v > self.vvelocidad[j] :
				v = self.vvelocidad[j]

			self.Velocidades[i][j] = v
				
			j += 1

	def NewPositions( self, indice ) :
		i = indice 
		j = 0
		while j<self._nv :
			v = self.Particulas[i][j] + self.Velocidades[i][j]

			if v < self.Limites[0][j] :
				v = self.Limites[0][j]
			elif v > self.Limites[1][j] :
				v = self.Limites[1][j]

			self.Particulas[i][j] = v
				
			j += 1

	def EvaluateOneParticle( self, indice ) :
		f, g = evaluate.Evaluate( self._nv, self.Particulas[indice] )
		self.Particulas[indice][self._nv] = f
		self.Particulas[indice][self._nv+1] = g

		# Here is the compasion with the best particle
		if g >=0 and self.vmejorPar[ self._const ] >= 0 :  # both are feasible
			if f  < self.vmejorPar[ self._nv ] :
				pass
			else :
				return

		elif g >=0 :        # Only the new one is feasible
			pass

		elif self.vmejorPar[ self._const ] >= 0: # The best one is feasible
			return

		elif g > self.vmejorPar[ self._const ] :  # The one with better constraints
			pass

		else :
			return

		j = 0
		while j <= self._const :
			self.vmejorPar[j] = self.Particulas[indice][j]
			j += 1


	def PrintBest( self ) :
		i = 0
		while i <= self._nv :
			print( self.vmejorPar[i], end=' ' )
			i += 1
		print( )
		# print self.Pop[k]
