import math
import sys

# Programa para calcular la raíz
# cuadrada de un número usando
# el método de Newton
#
# Fraga 23.08.2019
# Usamos la ecuación  f(x) = x^2 - n = 0
#                     f'(x) = 2x

def f( x ) :
	v = (x-2)*(x-5) + math.sin( 1.5*math.pi*x )
	return v

def df( x ) :
	#  x^2 - 7x + 10 +  sin( 1.5*.pi*x )
	# 2x - 7 + 1.5 * pi * cos( 1.5*pi*x)
	v1 = 1.5*math.pi
	v = 2.0*x - 7.0 + v1 * math.cos( v1*x )
	return v

def ddf( x ) :
	# 2x - 7 + 1.5 * pi * cos( 1.5*pi*x)
	# 2 - 1.5 * pi * sin( 1.5*pi*x) (1.5*pi)
	# 2 - (1.5 * pi)^2 * sin( 1.5*pi*x)
	v1 = 1.5*math.pi
	v = 2.0 - v1 * v1 * math.sin( v1*x )
	return v

n = len( sys.argv )
if n != 3:
	print( "Args: x1 x2" )
	sys.exit(1)

x1 = float( sys.argv[1] )
x2 = float( sys.argv[2] )

g1 = df( x1 )
g2 = df( x2 )

# Se cambian los puntos para tener el mínimo
if f(x1) < f(x2) :
	tmp = x1
	x1 = x2
	x2 = tmp

	tmp = g1
	g1 = g2
	g2 = tmp


#i = 0
#print( i, x2, f(x2), g2 )
i = 1
while i <= 30 :  # 20 iteraciones máximo
	deltax = x2 - x1
	deltag = g2 - g1

	if abs(deltag) < 1e-10 :
		alfa = 1.0
	else :
		alfa = deltax*deltag/(deltag*deltag)

	x1 = x2
	g1 = g2

	x2 = x2 - alfa * g2
	g2 = df( x2 )

	print( i, x2, f(x2), g2 )

	if math.fabs(g2) < 1e-14 :
		# if ddf(x2) > 0.0 :
		# 	print( "Es un mínimo" )
		# else :
		# 	print( "Es un máximo local" )
		break

	i += 1


print( i, x2, f(x2) )
